<?php

/**
 *      [Discuz!] (C)2001-2099 Comsenz Inc.
 *      This is NOT a freeware, use is subject to license terms
 *
 *      $Id: block_goods_comment.php 10773 2013-11-16 19:12:31Z mpage $
 */

if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

class block_goods_comment {

	var $setting = array();

	function block_goods_comment(){
		$this->setting = array(
			'commentids' => array(
				'title' => '指定点评',
				'type' => 'text'
			),
			'titlelength' => array(
				'title' => '标题长度',
				'type' => 'text',
				'default' => 40
			),
			'summarylength'	=> array(
				'title' => '简介长度',
				'type' => 'text',
				'default' => 80
			),
			'orderby' => array(
				'title' => '排序方式',
				'type' => 'mradio',
				'value' => array(
					array('dateline', '按发布时间倒序排序'),
					array('star', '按总体评价倒序排序')
				),
				'default' => 'dateline'
			)
		);
	}

	function getsetting() {
		global $_G;
		$settings = $this->setting;

		return $settings;
	}

	function name() {
		return '高级自定义';
	}

	function blockclass() {
		return array('goodscomment', '商品评论');
	}

	function fields() {
		return array(
				'url' => array('name' => '商品URL', 'formtype' => 'text', 'datatype' => 'string'),
				'title' => array('name' => '商品名称', 'formtype' => 'title', 'datatype' => 'title'),
				'pic' => array('name' => '商品图片', 'formtype' => 'pic', 'datatype' => 'pic'),
				'summary' => array('name' => '点评内容', 'formtype' => 'summary', 'datatype' => 'summary'),
				'avatar' => array('name' => '用户头像', 'formtype' => 'text', 'datatype' => 'string'),
				'dateline' => array('name' => '发布时间', 'formtype' => 'date', 'datatype' => 'date'),
				'star' => array('name' => '总体评价', 'formtype' => 'text', 'datatype' => 'int'),
				'username' => array('name' => '用户名', 'formtype' => 'text', 'datatype' => 'string'),
				'uid' => array('name' => 'UID', 'formtype' => 'text', 'datatype' => 'int'),
				'goods_id' => array('name' => '产品ID', 'formtype' => 'text', 'datatype' => 'int'),
			);
	}

	function cookparameter($parameter) {
		return $parameter;
	}

	function getdata($style, $parameter) {
		global $_G;

		$parameter = $this->cookparameter($parameter);

		$commentids		= !empty($parameter['commentids']) ? explode(',', $parameter['commentids']) : array();
		$items		= isset($parameter['items']) ? intval($parameter['items']) : 10;
		$titlelength	= !empty($parameter['titlelength']) ? intval($parameter['titlelength']) : 40;
		$summarylength	= !empty($parameter['summarylength']) ? intval($parameter['summarylength']) : 80;
		$orderby	= in_array($parameter['orderby'], array('dateline', 'star')) ? $parameter['orderby'] : 'dateline';

		$bannedids = !empty($parameter['bannedids']) ? explode(',', $parameter['bannedids']) : array();

		$wheresql = 'status = 0 AND goods_id > 0'
			.($commentids ? ' AND comment_id IN ('.dimplode($commentids).')' : '')
			.($bannedids ? ' AND comment_id NOT IN ('.dimplode($bannedids).')' : '')
		;

		$list = array();

		$query = DB::query("SELECT * FROM ".DB::table('dzapp_goods_comment')." WHERE $wheresql ORDER BY $orderby DESC LIMIT $items");
		while($data = DB::fetch($query)) {
			$goods_ids[] = $data['goods_id'];
			$list[$data['comment_id']] = array(
				'id' => $data['comment_id'],
				'goods_id' => $data['goods_id'],
				'idtype' => 'comment_id',
				'url' => 'plugin.php?id=dzapp_goods&mod=view&goods_id='.$data['goods_id'],
				'summary' => cutstr($data['message'], $summarylength, ''),
				'fields' => array(
					'fulltitle' => $goods[$data['goods_id']]['name'],
					'dateline' => $data['dateline'],
					'star' => $data['star'],
					'uid' => $data['uid'],
					'username' => $data['username'],
					'goods_id' => $data['goods_id'],
				)
			);
		}
		$goods = C::t('#dzapp_goods#dzapp_goods')->fetch_all($goods_ids);
		foreach($list as $key => $value) {
			$list[$key]['title'] = cutstr($goods[$value['goods_id']]['name'], $titlelength, '');
			$list[$key]['pic'] = $goods[$value['goods_id']]['pic'] ? 'portal/'.$goods[$value['goods_id']]['pic'] : STATICURL.'image/common/nophoto.gif';
			$list[$key]['picflag'] = $goods[$value['goods_id']]['pic'] ? '1' : '0';
		}

		return array('html' => '', 'data' => $list);
	}
}


?>